BigTree CMS 4.0
===============
<http://www.bigtreecms.org/>

Licensing
---------
BigTree CMS is publicly licensed under the [GNU Lesser General Public License](http://www.gnu.org/copyleft/lesser.html).
If you would like to use BigTree under a different license, please [contact us](mailto:info@fastspot.com).

Contributing
------------
We would love to have the community work with us on BigTree.  Guidelines are currently being created for how community contributions will be worked back into the project. For more information, please contact <contribute@bigtreecms.org>.  If you would like to begin developing the BigTree core, follow the process below:

1. Fork it.
2. Create a branch (`git checkout -b 4.0_toms_branch`)
3. Commit your changes (`git commit -am "Fixed My Broken Foot"`)
4. Push to the branch (`git push origin 4.0_toms_branch`)
5. Create an [Issue][1] with a link to your branch

Changelog
---------

### 4.0RC2
- ADDED: 404 Report now has paging and delete functionality.
- ADDED: Foreign key constraints to tables.
- ADDED: Module Views now pass their state information to forms so that when you return from the form you are where you left off.
- ADDED: Site Integrity Check now also checks module content.
- ADDED: More icons to choose from for module actions.
- ADDED: SQL queries are now logged to $bigtree["sql"]["queries"] when debug mode is on.
- ADDED: Support for module actions that contain /s in them so they can pretend to be in a subdirectory of custom modules.
- ADDED: Module Actions add/edit can now specify a form / view.
- ADDED: Placeholder image functionality.
- ADDED: BigTree::geocodeAddress
- ADDED: The ability to package instructions and post-install PHP code when importing a package.
- ADDED: You can now turn on/off tagging in modules and pages.
- ADDED: Delete All function for 404s without redirects entered.
- ADDED: Page titles should now reflect better where you are in the admin.
- ADDED: New, prettier email templates for daily digest / forgot password.
- ADDED: Searching in a grouped view now includes items in a group where the group name matches your query.
- ADDED: $bigtree["page"]["link"] now contains the equivalent of $cms->getLink($bigtree["page"]["id"]);
- ADDED: Default configuration variables to show a Development Area flag with a link to the website.
- ADDED: Default configuration variables to preload the admin with JS and CSS ($bigtree["config"]["admin_css"] and $bigtree["config"]["admin_js"] arrays)
- UPDATED: Consolidated a lot of images into a single sprite for faster loading of the admin.
- UPDATED: New glyph-based icon set and 2x image set for retina-capable displays.
- UPDATED: Google Analytics was completely revamped since RC1's authentication feeds were deprecated.
- UPDATED: Newer versions of TinyMCE and related plugins.
- UPDATED: The example site is updated to support "callouts" on the homepage for extensibility and also has had its code cleaned up.
- UPDATED: LESS compiler to support @import
- UPDATED: Credits page to be more comprehensive - linked it up in the footer.
- UPDATED: Example site blog now supports previewing.
- UPDATED: Adding a Geocoding or Many to Many to a form now automatically brings up the settings dialog.
- FIXED: BigTreeAutoModule's getViewForTable should be static.
- FIXED: "route" being limited to 30 characters in bigtree_pages.
- FIXED: View Columns should no longer break if they were styled and a Preview button was added.
- FIXED: Parameters for BigTreeCMS's getBreadcrumb function were wrong.
- FIXED: BigTree admin's login page should now load resources over HTTPS if force_secure_login is set in the config.
- FIXED: Documentation bugs
- FIXED: File Extensions not being set in the database correctly for things uploaded to the File Manager.
- FIXED: Issue with hidden resources in Callouts.
- FIXED: Users section should now have sortable columns and paging should now work properly.
- FIXED: Permission issue with drag and drop.
- FIXED: A bug with Array of Items in Chrome.
- FIXED: Site Status crashing if PHP was running as CGI.
- FIXED: Several Module import/export issues.
- FIXED: Date/Time picker styles in WebKit browsers.
- FIXED: Thumbnail images in dialog pop-ups.
- FIXED: Misbehavior of the Field Selector for Module Forms.
- FIXED: Unintended creation of orphaned temporary images.
- FIXED: Views crashing if all the columns were removed.
- FIXED: Inclusion of hidden files in /custom/inc/required/
- FIXED: Poor english in some places.
- FIXED: CSS and JavaScript not getting Last-Modified headers causing redownloads each time.
- FIXED: Administrators not being able to archive top level hidden pages.
- FIXED: Random CSS/JS cache files being created. Only combinations set in the config will create them now.
- FIXED: Missing "default to now" option for Date & Time picker.
- FIXED: Date & Time picker showing a default date of 1969.
- FIXED: Missing "Required" option for Date/Time/Date & Time pickers.
- FIXED: Custom view actions not being able to be disabled after added.
- FIXED: Content Alert inheritance buttons in user editor.
- FIXED: Double encoding of html special characters in module views.
- FIXED: Odd encoding issue on pre/post process module form functions.
- FIXED: Site Status now properly checks all directories for writability.
- FIXED: Some BigTreeForms methods being public instead of static.
- FIXED: Sorting in grouped image views.
- FIXED: BigTreeAdmin::deleteFieldType now properly removes the options file.
- FIXED: A bug in BigTree::trimLength
- FIXED: Improper headers being sent for images served through TinyMCE's javascript folder.
- FIXED: A bug with the view cache and pending entries.
- FIXED: Many to Many bugging out if there were no possible relationships to be made.
- FIXED: Fields not being validated when creating a form / action / view.
- FIXED: Settings not translating properly.
- FIXED: Not being able to preview an expired or publish-in-the-future page.
- FIXED: Save & Preview not working in Pages when there were crops.
- FIXED: Front end cropping not closing the window properly.
- FIXED: Breadcrumb breaking in Pages if trunk was set.
- FIXED: Int fields that were empty and didn't accept NULL being butchered.
- FIXED: Forgot Password email coming from @bigtreecms.com
- FIXED: Group sorting when it was sorting by numeric values.
- FIXED: Page revisions never falling off after 10 / more than a month old.
- FIXED: BigTreeSelect not recognizing when a <select> was disabled.
- FIXED: Numeric commands not being passed to module actions.
- FIXED: Various issues related to pending changes.
- FIXED: Grouped view items where the item's group is missing.
- FIXED: Template creation no longer creates a "Resources Available" comment if none are available.
- FIXED: Columns named "route" should now be assumed as the Generated Route field type.
- FIXED: BigTree::copyFile so that it supports URLs for the source.
- FIXED: An issue with module forms doubling when exporting a module.
- FIXED: An issue where adding a new resource to a callout wouldn't let you save it's radio button value.
- FIXED: A text overflow issue on view columns.
- FIXED: BigTreeModule::search method.
- FIXED: BigTreeCMS::getLink now recognizes if you're requesting the current page's link and doesn't ask the database for it.
- FIXED: Amazon S3 storage settings not sticking properly.
- FIXED: Caching of unpublished view items.
- FIXED: BigTreeAdmin::autoIPL issue with URLs where text followed.
- FIXED: Lots of issues with tables where column names contained spaces or `
- FIXED: Column sorting in searchable views.
- FIXED: Problems caused by the column set to sort by wasn't included in the view.
- FIXED: IE10 background gradient support.
- FIXED: Failed photo uploads causing the field to be filled with the value of the previous field.
- FIXED: View paging not making sense if there were more than ~5 pages.
- FIXED: Admin crashing if the table for a form/view was deleted when trying to edit them.
- FIXED: Crashes in database populated lists when the table it pulled from was deleted.
- FIXED: Front end editor should no longer show Edit if the user doesn't have access to edit the page.
- FIXED: Editing a page should now return you to the page you were previously on instead of always its parent.
- FIXED: Quick Search is now more clear about the existence of Advanced Search.
- FIXED: Previewing the homepage.
- FIXED: Issues where a person with different group based permissions on a single module could escalate their editor/publisher rights.
- FIXED: Improper calculation of quarterly reporting for Google Analytics.
- FIXED: Issues with Analytics crashing the cron update so that it never sends Daily Digest email updates.
- FIXED: Demo site should now properly respect publish dates on blog entries.
- FIXED: Double encoding of relationships in Many to Many fields.
- FIXED: Adding Geocoding to forms.
- FIXED: Images not showing up in advanced search.
- CHANGED: Page Header and Page Content are no longer required fields in the example site's Content template.
- CHANGED: Simple HTML WYSIWYG no longer has the Code option.
- CHANGED: Passing of information in Developer section from using commands to GET to be more clear.
- CHANGED: Admin area now uses $_SESSION["bigtree_admin"] instead of $_SESSION["bigtree"] to avoid register_globals breaking front ends.
- CHANGED: BigTree now defaults to MySQLi instead of MySQL.
- CHANGED: BigTree now uses sqlescape() instead of mysql_real_escape_string so that it can cooperate with MySQLi and MySQL.
- CHANGED: Improved the layout of Site Integrity Check
- CHANGED: Crops will now be a square if only one dimension was entered.
- CHANGED: Display of editing a Setting.
- CHANGED: If a class is not found when auto loading, it will clear the module class list cache file in case it's out of date.
- CHANGED: sqlfetch() calls will no longer throw an exception if you don't have debug on.
- CHANGED: Tagging now associates by table instead of module.
- CHANGED: SQL commands are now in /core/inc/bigtree/sql.php, moved most of /core/inc/utils/ into /core/inc/lib/ to be more accurate in the naming.
- CHANGED: Installer now uses the main admin's css/js instead of a custom subset.
- CHANGED: Several items that were always included in bootstrap are now auto loaded when needed.
- CHANGED: Consolidated code for replacing relative/hard roots.
- CHANGED: Approving a change now growls the proper module name.
- CHANGED: If an error is thrown in Pages, the tab is now switched to the first tab that contains an error.
- CHANGED: Routing now supports unlimited depth levels of _header and _footer and routing code has been consolidated and optimized.
- CHANGED: Many to Many's list parser function now parses both the list of available relationships as well as the list of existing relationships.
- CHANGED: BigTreeModule::search is now case insensitive by default.
- CHANGED: New default layout for the admin includes H1s, breadcrumb, and navigation for modules. THIS MAY CAUSE BACKWARDS COMPATIBILITY ISSUES WITH CUSTOM MODULES THAT DRAW IT ON THEIR OWN.
- CHANGED: Including custom CSS and JavaScript in the admin is now done through $bigtree["css"] and $bigtree["js"] instead of $css and $js — THIS IS A BACKWARDS COMPATIBILITY BREAK FOR CUSTOM MODULES.
- CHANGED: form_container class name is now container - THIS IS A BACKWARDS COMPATIBILITY BREAK FOR CUSTOM MODULES. 
- CHANGED: Cropping code is now consolidated across modules/pages.
- CHANGED: Pages tab should no longer be in the header if a user has no pages access.
- CHANGED: BigTreeBar javascript is now namespaced better in a JavaScript object.
- CHANGED: Users with Group Based publisher permission can now publish their entry if they choose a group they have publish access to without first saving it.
- CHANGED: Switching a select that affects the group based permissions of an entry now changes the button actions at the bottom of the form.
- CHANGED: The permissions tree in the User editor should auto-expand down to where specific permissions have been set.
- CHANGED: SQL connection parameters are now removed after the connection is made for security when debugging the $bigtree environment variable.
- REMOVED: Dropdown of modules from the main header.
- REMOVED: getPendingPage and getTagsForPage from BigTreeAdmin since they were redundant with BigTreeCMS's implmentation.

### 4.0RC1
- NEW: Retina Display asset support (create 2x images at lower quality when capable)
- NEW: Forms can now manually specify a return view.
- NEW: Image quality settings can now be set in /templates/config.php for both retina images and regular images (previously BigTree always used 90%).
- NEW: Crops and thumbnails can now be given grayscale treatment.
- UPDATED: Custom <select>s now support <optgroup>
- UPDATED: Thumbnails of cropped images now re-crop from the original image to preserve quality.
- UPDATED: Template add/edit now groups Related Modules in <optgroups> for easier choosing of modules with the same name.
- FIXED: Form's action routes not updating if suffix changed.
- FIXED: Searchable view sorting.
- FIXED: Template creation now throws an error message if you try to use an existing ID.
- FIXED: # being thrown if you click on an already active tab in Pages. Now scrolls to the top.
- FIXED: Regular user permissions that totally got screwed in beta 7.
- FIXED: Trunk support in BigTreeCMS::getToplevelNavigationIdByPage
- FIXED: Duplicate entries sometimes occurring in sitemap.xml
- FIXED: Warning being thrown for output filters being false in router.
- FIXED: Terminology on Callout add/edit page. Fixed options button being in the wrong place as well. Fixed doubled radio buttons.
- FIXED: Group based permissions being checked off for modules where it was null.
- FIXED: Options button in Module Designer.
- FIXED: Image Views ignoring the "Edit" function being deactivated.
- FIXED: Admin not redirecting to the requested page if it was requested when you weren't logged in. (Now returns to the requested page after login).
- FIXED: Dialogs not re-centering if their height changed.
- FIXED: Template tab in Pages now hides if a user doesn't have access to the template that is currently set (i.e. the template is Administrator or Developer only).
- FIXED: Auto Modules now properly refresh their locks on content every minute.
- FIXED: Double encoding of the names of Field Types (leading to &amp; showing up).
- FIXED: Missing image when adding an image to a photo gallery for the first time.
- FIXED: Packaging a module with tables that had foreign keys not being packaged in the proper order (leading to failed creation of tables due to foreign key constraints).
- RETURNED: Support for /sitemap/ defaulting to /templates/basic/_sitemap.php
- REMOVED: Imagick support. GD support remains.

### 4.0b7
- NEW: Redesigned sample site that provides more in depth examples of using BigTree
- NEW: Field Types are now able to be used in Settings
- NEW: Gravatar support for users
- NEW: Date Time Picker support
- NEW: BigTree::describeTable method for a faster way to get SQL table columns
- NEW: Foreign key constraints are now recognized when creating a form and are automatically created to be database populated lists.
- NEW: ENUM columns are now recognized when creating a form and are automatically created to be static lists.
- NEW: BigTreeModule::getSitemap method to allow for drawing sitemap branches from a module class.
- UPDATED: LESS Compiler to 0.3.5
- UPDATED: Authentication no longer caches permissions via sessions.
- UPDATED: New installs now set SERVER_ROOT in /site/index.php to allow for sym-linked /core/ folders.
- UPDATED: Install.php can now accept command line options instead of $_POST vars for automated installs.
- UPDATED: New installs will receive indexes and foreign key constraints on bigtree core tables.
- UPDATED: Retina assets for custom controls.
- UPDATED: CSS parsing to include root variable auto replacing (www_root/ admin_root/ static_root/ etc).
- FIXED: Custom select boxes now blur other select boxes when clicked.
- FIXED: Custom select boxes now scroll the window down to show their full drop down when low on the page.
- FIXED: A bug with SEO scoring unique titles improperly.
- FIXED: Turning on notices when debugging a custom module shouldn't break the whole admin now.
- FIXED: Bug related to locked pages/entries.
- FIXED: Searching users, settings, and resources is no longer case sensitive
- FIXED: Missing jump dropdown in Dashboard areas.
- FIXED: Searching auto modules is no longer case sensitive
- FIXED: Missing "custom" fields in view options, field options, other dialogs
- FIXED: Default templates using $content instead of $bigtree["content"]
- FIXED: Google Analytics setup failing to store encrypted information properly in the database.
- FIXED: Dialogs now stay centered on the screen when the browser resizes.
- FIXED: Bug that caused image resources to use {wwwroot} over {staticroot}
- FIXED: Empty module groups are no longer shown in the Modules dropdown
- FIXED: File Browser "Cancel" button not closing the window when packaging a module.
- FIXED: The front end editor now alerts a user if there is no editable content.
- FIXED: Custom selects misbehaving in dialogs
- FIXED: Sorting via fields not using backticks (`) around column names
- FIXED: RSS 2 feeds not really being RSS 2.0
- FIXED: Warning that could show when preprocessing functions didn't return an array
- FIXED: A rare bug where creating a new item in a module before the module's view was cached would make the existing items never cache.
- REMOVED: Custom JavaScript and CSS in Auto Module forms.
- REMOVED: Uncached ability in Auto Module views.

### 4.0b6
- NEW: BigTree now allows for usage of index.php routing WITHOUT .htaccess / mod_rewrite
- NEW: BigTree::unzip function (preparing for the future)
- FIXED: Buttons in the image browser not working in beta 5.
- FIXED: Example site "Wonders" form missing in beta 5.
- FIXED: Module forms not creating properly in beta 5.
- FIXED: Choosing image size not working in Image Browser in beta 5.
- FIXED: Styles of the H3 in the image size chooser in the Image Browser.
- FIXED:  404s in the 404 list not being htmlspecialchar'd
- FIXED: Some "Advanced Link" problems in TinyMCE
- FIXED: Views with more than 5 columns causing a critical error.
- FIXED: Many problems that stopped module packaging / importing from working in recent betas.
- FIXED: Callout images throwing an error if they were unchanged from last publish (Thanks Phil P!)
- FIXED: A warning that occurred if you uploaded an invalid image.
- FIXED: Lazy loading of modules throwing a critical error when class_exists() was called (fixes Module Designer!)
- FIXED: Module creation process showing urlencoded titles
- FIXED: Homepage resources loading into a new page if the template was changed (Thanks Phil P!)

### 4.0b5
- NEW: Array of Items now supports using several different field types (text, textarea, date, time, html)
- NEW: BigTree version updater automatically does database and file system changes when a new revision is installed.
- NEW: "Trunk" flag for pages that allows for resetting BigTreeCMS::getTopLevelNav and BigTreeCMS::getBreadcrumbByPage methods.
- UPDATED: TinyMCE to latest version.
- UPDATED: BigTreeAdmin::updateSetting now supports system settings.
- UPDATED: System settings are now consolidated to not clutter the bigtree_settings table so much.
- UPDATED: Cleaned up list-generating code to be usable by third party field types (see BigTreeListMaker JavaScript class).
- UPDATED: Callouts "Title" now renamed "Label" so there aren't two things called "Title".
- UPDATED: Daily Digest email now sends out emails alerting you of unread messages in Message Center.
- UPDATED: Cleaned up the global namespace to move several variables ($content, $layout, $page, $callouts, $resources) into a $bigtree array variable.
- FIXED: A possible notice in install.php
- FIXED: Updating a pending page change (fixes restoring to a revision when a pending change to a page exists)
- FIXED: "Cron" no longer tries to run Google Analytics if a profile isn't set.
- FIXED: The size of some panels in the Image/File browser.
- FIXED: Many to Many editor's odd style issues.
- FIXED: Generated routes failing when publishing a pending item.
- FIXED: Preview URL for the homepage.
- FIXED: Double-encoding of HTML entities for callouts.
- FIXED: Errors for "Array of Items" when used in callouts.
- FIXED: Some issues with inline popups in TinyMCE.
- FIXED: Custom select boxes were firing "changed" instead of "change" like a normal <select> element would.
- FIXED: Tooltips not hiding properly (and causing things behind them to be unclickable)
- FIXED: Creating a user not setting the daily digest flag properly.
- FIXED: "Cron" not getting the right environment variables when running daily digest.
- FIXED: "Growl" messages not showing up in Users section.
- FIXED: Users rows not disappearing after deleting them.
- FIXED: Deleting a user confirmation dialog saying "Resource" instead of "User"
- FIXED: Styling and clickablility of Quick Search results in admin.
- FIXED: File Browser in IE8, removed it's use with a warning in < IE8.
- FIXED: Sub directories are no longer (attempted to be) included in /custom/inc/required/ (thus throwing a warning)
- FIXED: Pages not publishing certain properties properly when published via the Pending Changes section of Dashboard.
- FIXED: Saving a revision not showing the new revision immediately.
- FIXED: Array of Items not getting a draggable placeholder
- FIXED: Daily digest going out even if there was nothing for the user to be notified about.

### 4.0b4
- Fixed issues with saving pending changes on pages that were empty of content.
- Fixed publishing pending changes for pages from the dashboard
- Fixed the number of pending page changes on the dashboard always showing 1.
- Updated the layout of the user permission editor to list modules by group.
- Fixed the module permissions always showing a blue arrow even when sub-permissions were not available.
- Fixed default date format for the date picker if "Default to Today's Date" was set.
- Fixed callout files/images disappearing on re-save
- Fixed resources in callouts saving strangely.
- Fixed callout resources ignoring validation rules.
- Restored ability to add classes to images in TinyMCE
- Added missing + buttons in module designer.
- Removed confirm dialogs from deleting fields from a form.
- Fixed an error that caused options for a view to not save (and throw a warning) on initial creation.
- Fixed cron-job not running properly.
- Fixed BigTreeCMS::makeSecure
- Fixed a few Javascript events in the admin (changing callout types and a few other places were broken in beta 3)
- Switched sorting in the admin to use POST instead of GET (to support thousands of items).

### 4.0b3
- Updated image cropper count design to make the number of crops more obvious
- Updated callouts to allow developers to set a default title.
- Updated module creation so that if there isn't a related table it throws a growl and moves away from the view/form creation process.
- Fixed custom view actions behavior.
- Fixed BigTreeModule::getTagsForItem
- Changed positions to always be position: fixed instead of a mix of fixed and absolute.
- Fixed the variable scope in which _404.php is included on 404 pages.
- Fixed pulling module class' breadcrumb.
- Fixed BigTreeCMS::urlify to properly decode html entities before creating a URL string (prevents this-amp-that type URLs).
- Fixed some z-index issues with dialog windows.
- Fixed Array of Items field type item order to be consistent with List.
- Fixed using view actions (feature, archive, approve, dragging to change position) on items that are not yet published.
- Fixed TinyMCE paste problems.
- Added the ability to specify a required user level for a module action to appear in a module's admin navigation.
- Updated the Home template to default to developer-only and set its position to be second in the list of default templates (so that content is the default for new pages).
- Fixed (Database Populated) List field type not remembering your sort order the first time you create it.
- Fixed Field Types not remembering whether they're allowed for Callouts on initial creation.
- Fixed link to analytics on the dashboard.
- Fixed Feeds not loading properly on the front end.
- Fixed route history not being created when moving pages.
- Fixed CSS border radius in several places in Safari.
- Fixed grouped module breadcrumb going to the wrong place if you clicked the group name.
- Fixed module designer creating the wrong icons and in the wrong order.
- Updated BigTreeAdmin::createModuleAction to allow you to specify a default position.
- Updated view caching to process out {wwwroot}
- Fixed Module View creation to throw proper errors on draggableness (previously checked the wrong properties so false errors were thrown and real ones were missed)
- Added + icons to the edit module screen.
- Silenced some warnings when images had bad EXIF data.
- Made initial content age be the date of installation instead of 1969.
- Fixed install / admin errors when Notices were turned on in PHP.
- Updated the style of the Unused Field adding mechanism to more accurately group the + icon and the field name together.  Thanks philp!
- Fixed the front end editor messing up page titles / nav titles that had & in them.
- Updated sqlfetch() to throw an Exception when you give it a bad sqlquery() result to aid in debugging.
- Added BigTreePaymentGateway -- a way to handle payment gateways without knowing which one the user has.
- Updated the layout of the developer landing to support Payment Gateways.
- Fixed styling of phone / email field types when in callout editor.
- Fixed callout's phone number processing.
- Fixed the initial description of a callout's resources that's written to the callout file.
- Fixed mobile.css and no-zoom/resize being set for mobile browsers (should work now on iPhone/Android, though not optimized for it yet).
- Added placeholder styles for dragging of callouts and image views.
- Fixed image views not using the "prefix" option properly.
- Changed to native event firing on custom Select, Radio, and Checkboxes in the admin (used to be checked:click and select:changed, now you just observe click or changed).
- Fixed Google Analytics and Daily Digest not sending out in the event that your cron isn't running (should have happened on any visit to the admin if cron hasn't run in 24 hours, wasn't)
- Fixed File Browser not working on the front end editor.
- Stopped the home page from being able to be moved.

### 4.0b2
- Removed .htaccess warnings from the installer since it's throwing a lot of warnings when there isn't a problem.
- Fixed page "Revisions" showing the currently published copy as an option for creating a new draft.
- Fixed fatal error that's thrown when an item was locked and someone else tried to access it.
- Updated BigTree::curl to not verify SSL host/peer (caused lots of failed cURLs)
- Fixed a warning thrown when calculating SEO value if some of the field types were arrays in a page template.
- Silenced some warnings in the installer (caused by shared server openbase_dir stuff).
- Fixed styles in the example site.
- Fixed an error that caused issues with grouped views in modules.
- Removed the ability to use Field Wrappers.
- Changed the default sorting for templates.
- Changed the "name" field of resources of callouts to be "title" like everything else (if you've made some callouts, their titles may not be working now, sorry!)
- Fixed some errors in processing photo gallery field types.
- Fixed a bug with file dialogs when hitting Escape to close them.
- Updated the user editor to hide permissions that aren't applicable to Administrators and Developers.
- Fixed text-ellipsis for long URLs in the Properties section of pages.
- Fixing pending changes to pages not decoding properly (caused broken images in HTML areas).
- Added + icons to buttons in forms to bring better attention to them adding things.
- Removed extraneous old code from BigTree 3.3
- Fixed some HTML5 validation errors.
- Fixed a tag closing bug that was causing Internet Explorer to not render the nav properly.
- Fixed a bug with tagging items not sticking.
- Fixed a message when deleting a 404.

### 4.0b1
- Initial public release.
